/*
 * squareExplore.h
 *
 * Robert Hochberg
 * April 10, 2012
 *
 * Find rational periodic points of the x -> x^2+c iteration
 */

#include <stdio.h>
#include <math.h>
#include <cuda.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <math.h>

// Thread block size 
#ifndef BLOCKSIZE
#define BLOCKSIZE 16 
#endif

typedef enum {NUMERATOR, DENOMINATOR} fracpos;

// Global Variables
double* hResults;
void* dResults;
double* hDenomVals;		/*   host array for denom values */
void* dDenomVals;		/* device array for denom values */
size_t acount, xcount, stride;
double threshold;
double gdepth;			/* #iterations for continued fracs */
double gcolor;			/* offset for color cycling        */
int iterations;
double gxmin, gxmax, gxstep;
double gamin, gamax, gastep;
double cur_x, cur_y, cur_x2, cur_y2; //for dragging zoom
char gMouseXLoc[25], gMouseALoc[25];	     /* mouse locations at any time */
char gIterationLoc[25], gDepthLoc[25]; 
char gFracX[25], gFracA[25]; 

bool g_bButton1Down;
bool zoomSelect;
int mainWindow, textWindow;
double xMotionLoc, yMotionLoc;

// Function Decleration
void recompute(double xmin, double xmax, double xstep, double amin, double amax, double astep, int numIt, size_t stride, double* dResults);
void drawSquare(double x, double y);
unsigned long long int fracEntry(double a, fracpos tob, int depth);
