/*
 * squareExploreNoCuda.h
 *
 * Robert Hochberg
 * April 10, 2012
 *
 * Find rational periodic points of the x -> x^2+c iteration
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>

#ifdef __APPLE__
#  include <OpenGL/gl.h>
#  include <OpenGL/glu.h>
#  include <GLUT/glut.h>
#else
#  include <GL/gl.h>
#  include <GL/glu.h>
#  include <GL/glut.h>
#endif

// Global Variables
double* hResults;
double* hDenomVals;		/*   host array for denom values */
size_t acount, xcount, stride;
double threshold;
double gdepth;			/* #iterations for continued fracs */
double gcolor;			/* offset for color cycling        */
int iterations;
double gxmin, gxmax, gxstep;
double gamin, gamax, gastep;
double cur_x, cur_y, cur_x2, cur_y2; //for dragging zoom
char gMouseXLoc[25], gMouseYLoc[25];	     /* mouse locations at any time */
char gIterationLoc[25], gDepthLoc[25]; 
bool g_bButton1Down;
bool zoomSelect;
int mainWindow, textWindow;
double xMotionLoc, yMotionLoc;
int  framesSoFar;		/* For computing frames per second */
int  frameTimes[50];

// Function Decleration
void recompute(double xmin, double xmax, double xstep, double amin, double amax, double astep, int numIt, size_t stride, double* hResults);
void drawSquare(double x, double y);
